import { FileSystem, LanguageServicePlugin } from '@volar/language-service';
import { SnapshotDocument } from '@volar/snapshot-document';
import * as vscode from 'vscode-languageserver';
import type { ServerProjectProvider, VolarInitializeParams } from './types.js';
export * from '@volar/snapshot-document';
export declare function createServerBase(connection: vscode.Connection, getFs: (initializeParams: VolarInitializeParams) => FileSystem): {
    connection: vscode.Connection;
    initializeParams: VolarInitializeParams;
    languageServicePlugins: LanguageServicePlugin<any>[];
    projects: ServerProjectProvider;
    fs: FileSystem;
    semanticTokensLegend: vscode.SemanticTokensLegend;
    pullModelDiagnostics: boolean;
    documents: vscode.TextDocuments<SnapshotDocument>;
    workspaceFolders: {
        clear: () => void;
        values: () => IterableIterator<boolean>;
        uriKeys: () => IterableIterator<string>;
        uriDelete: (_uri: string) => boolean;
        uriGet: (_uri: string) => boolean | undefined;
        uriHas: (_uri: string) => boolean;
        uriSet: (_uri: string, item: boolean) => void;
        pathDelete: (path: string) => boolean;
        pathGet: (path: string) => boolean | undefined;
        pathHas: (path: string) => boolean | undefined;
        pathSet: (path: string, item: boolean) => void;
    };
    initialize: (initializeParams: VolarInitializeParams, languageServicePlugins: LanguageServicePlugin[], projects: ServerProjectProvider, options?: {
        semanticTokensLegend?: vscode.SemanticTokensLegend;
        pullModelDiagnostics?: boolean;
    }) => vscode.InitializeResult<any>;
    initialized: () => void;
    shutdown: () => Promise<void>;
    watchFiles: (patterns: string[]) => void;
    getConfiguration: <T>(section: string, scopeUri?: string) => Promise<T | undefined>;
    onDidChangeConfiguration: (cb: vscode.NotificationHandler<vscode.DidChangeConfigurationParams>) => {
        dispose(): void;
    };
    onDidChangeWatchedFiles: (cb: vscode.NotificationHandler<vscode.DidChangeWatchedFilesParams>) => {
        dispose: () => void;
    };
    clearPushDiagnostics: () => void;
    refresh: (projects: ServerProjectProvider) => Promise<void>;
};
